/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Manual Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <string.h>

#include <oo.h>
#include "OO7.h"
#include "GenParams.h"
#include "VarParams.h"

extern int	debugMode;

////////////////////////////////////////////////////////////////////////////
//
// Manual Constructor
//
////////////////////////////////////////////////////////////////////////////

Manual::Manual(int32 modId)
{
    // fill in id

    id = modId;

    // prepare and fill in the manual title

    sprintf(title, "Module         %08d", modId);
    if (debugMode) {
        printf("Manual::Manual(title = %s)\n", title);
    }

    // prepare and fill in the manual text

    char myText[ManualTextLength];
    sprintf(myText, ManualText, modId);
    int stringLen = strlen(myText);
    text.update();
    text.resize(ManualSize);
    int curChar, strChar;
    curChar = strChar = 0;
    char *memText = &text.elem(0);
    while (curChar < ManualSize-1) {
       memText[curChar++] = myText[strChar++];
       if (strChar >= stringLen) { strChar = 0; }
    }
    memText[curChar] = '\0';
}


////////////////////////////////////////////////////////////////////////////
//
// Manual searchText Method for use in traversals
//
////////////////////////////////////////////////////////////////////////////

int Manual::searchText(char c)
{
    if (debugMode) {
        printf("                    Manual::searchText(title = %s)\n", title);
    }

    // count occurrences of the indicated letter (for busy work)

    int i, count = 0;
    int stringLen = text.size();
    char *memText = &text.elem(0);
    for (i = 0; i < stringLen; i++) {
	if (memText[i] == c) { count++; }
    }

    if (debugMode) {
        printf("                    [found %d '%c's among %d characters]\n",
	        		     count, c, i);
    }

    return count;
}


//////////////////////////////////////////////////////////////////////////
//
// Manual firstLast method. 
//
//////////////////////////////////////////////////////////////////////////
int Manual::firstLast()
{
    if (debugMode) {
        printf("                    Manual::firstLast(title = %s)\n", title);
    }

    int i, match = 0;

    int stringLen = text.size();

    char *memText = &text.elem(0);

    return (memText[0] == memText[stringLen-1]); 
}


